HDU 1885 Key Task 状态压缩+搜索

点击打开链接

Key Task

Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 1176    Accepted Submission(s): 462

Problem Description

The Czech Technical University is rather old — you already know that it celebrates 300 years of its existence in 2007. Some of the university buildings are old as well. And the navigation in old buildings can sometimes be a little bit tricky, because of strange
long corridors that fork and join at absolutely unexpected places.

The result is that some first-graders have often di?culties finding the right way to their classes. Therefore, the Student Union has developed a computer game to help the students to practice their orientation skills. The goal of the game is to find the way
out of a labyrinth. Your task is to write a verification software that solves this game.

The labyrinth is a 2-dimensional grid of squares, each square is either free or filled with a wall. Some of the free squares may contain doors or keys. There are four di?erent types of keys and doors: blue, yellow, red, and green. Each key can open only doors
of the same color.

You can move between adjacent free squares vertically or horizontally, diagonal movement is not allowed. You may not go across walls and you cannot leave the labyrinth area. If a square contains a door, you may go there only if you have stepped on a square
with an appropriate key before.

Input

The input consists of several maps. Each map begins with a line containing two integer numbers R and C (1 ≤ R, C ≤ 100) specifying the map size. Then there are R lines each containing C characters. Each character is one of the following:

Note that it is allowed to have

  • more than one exit,
  • no exit at all,
  • more doors and/or keys of the same color, and
  • keys without corresponding doors and vice versa.

    You may assume that the marker of your position (“*”) will appear exactly once in every map.

    There is one blank line after each map. The input is terminated by two zeros in place of the map size.

  • Output

    For each map, print one line containing the sentence “Escape possible in S steps.”, where S is the smallest possible number of step to reach any of the exits. If no exit can be reached, output the string “The poor student is trapped!” instead.

    One step is defined as a movement between two adjacent cells. Grabbing a key or unlocking a door does not count as a step.

    Sample Input

    1 10
    *........X
    
    1 3
    *#X
    
    3 20
    ####################
    #XY.gBr.*.Rb.G.GG.y#
    ####################
    
    0 0
    

    Sample Output

    Escape possible in 9 steps.
    The poor student is trapped!
    Escape possible in 45 steps.
    

    每个位置有16种状态,可以用一个vis三维数组表示每个点的16种状态,对于四种锁,每种锁用一位来表示,有钥匙标记为1,否则标记为0.然后bfs搜索一下就行了。

    //109MS	556K
    #include<stdio.h>
    #include<queue>
    #include<string.h>
    #include<algorithm>
    #define M 107
    using namespace std;
    int n,m,s,t;
    int dir[4][2]={{-1,0},{1,0},{0,1},{0,-1}};
    char g[M][M];
    bool vis[M][M][17];
    char up[4]={'B','Y','R','G'};
    char low[4]={'b','y','r','g'};
    struct node
    {
        int step,x,y,key;
    };
    int bfs()
    {
        queue<node>q;
        node now,next;
        now.x=s;now.y=t;now.step=now.key=0;
        vis[s][t][0]=true;
        q.push(now);
        while(!q.empty())
        {
            now=q.front();
            q.pop();
            if(g[now.x][now.y]=='X')return now.step;
            for(int i=0;i<4;i++)
            {
                next.x=now.x+dir[i][0];
                next.y=now.y+dir[i][1];
                next.step=now.step+1;
                next.key=now.key;
                if(next.x<1||next.x>n||next.y<1||next.y>m||g[next.x][next.y]=='#')continue;//如果越界
                if(g[next.x][next.y]>='A'&&g[next.x][next.y]<='Z'&&g[next.x][next.y]!='X')
                {
                    for(int j=0;j<4;j++)
                        if(g[next.x][next.y]==up[j])
                        {
                            if(next.key&(1<<j)&&!vis[next.x][next.y][next.key])//如果没有访问过且拥有此锁的钥匙
                            {
                                vis[next.x][next.y][next.key]=true;
                                q.push(next);
                            }
                            break;
                        }
                }
                else if(g[next.x][next.y]>='a'&&g[next.x][next.y]<='z')
                {
                    for(int j=0;j<4;j++)
                        if(g[next.x][next.y]==low[j])
                        {
                            if((next.key&(1<<j))==0)//如果没有此钥匙
                                next.key+=(1<<j);
                            if(!vis[next.x][next.y][next.key])
                            {
                                vis[next.x][next.y][next.key]=true;
                                q.push(next);
                            }
                        }
                }
                else
                {
                    if(!vis[next.x][next.y][next.key])
                    {
                        vis[next.x][next.y][next.key]=true;
                        q.push(next);
                    }
                }
            }
        }
        return -1;
    }
    int main()
    {
        while(scanf("%d%d",&n,&m),n|m)
        {
            memset(vis,false,sizeof(vis));
            for(int i=1;i<=n;i++)
            {
                scanf("%s",g[i]+1);
                for(int j=1;j<=m;j++)
                    if(g[i][j]=='*'){s=i;t=j;}
            }
            int ans=bfs();
            if(ans==-1)printf("The poor student is trapped!\n");
            else printf("Escape possible in %d steps.\n",ans);
        }
        return 0;
    }
    

    HDU 1885 Key Task 状态压缩+搜索

    时间: 2024-11-11 01:59:35

    HDU 1885 Key Task 状态压缩+搜索的相关文章

    HDU 1885 Key Task 国家压缩+搜索

    点击打开链接 Key Task Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1176    Accepted Submission(s): 462 Problem Description The Czech Technical University is rather old - you already know that it c

    hdu 1885 Key Task (三维bfs)

    题目 之前比赛的一个题, 当时是崔老师做的,今天我自己做了一下.... 还要注意用bfs的时候  有时候并不是最先到达的就是答案,比如HDU 3442 这道题是要求最小的消耗血量伤害,但是并不是最先到达目标点的路径 就是最小的伤害,因为每一个点的伤害是 不一样的, 这种情况要用优先队列优化, 对伤害优化. 题意:*开始, X出口, b, y, r, g 代表钥匙,分别可以开B, Y, R, G颜色的门, 钥匙可以多次使用.问最短的步骤. 思路:vis[][][]数组开三维,第三维记录状态 是否拿

    hdu 1885 Key Task(bfs+状态压缩)

    Problem Description The Czech Technical University is rather old — you already know that it celebrates 300 years of its existence in 2007. Some of the university buildings are old as well. And the navigation in old buildings can sometimes be a little

    HDU 1885 Key Task

    bfs. 一把某种颜色的锁开 所有这个颜色的门. 状态检查压缩一下  vis[][][2^4]; 跟HDU 1429 类似.至于颜色判断我用了 map: #include<cstdio> #include<cstring> #include<string> #include<queue> #include<algorithm> #include<map> #include<stack> #include<iostre

    hdoj 1885 Key Task 【BFS+状态压缩】

    题目:hdoj 1885 Key Task 题意:给出一些点,然后有一些钥匙和门,钥匙拿到才可以打开门,问到出口的最短时间. 分析:很明显的广搜 + 状态压缩题目. 坑点: 1:题目没读清楚,以为要把所有的们打开才能出去. AC代码: #include <iostream> #include <stdio.h> #include <string.h> #include <algorithm> #include <queue> #include &

    hdu 3217 Health(状态压缩DP)

    Health Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 527    Accepted Submission(s): 145 Problem Description Unfortunately YY gets ill, but he does not want to go to hospital. His girlfriend LM

    hdu 4856 Tunnels(bfs+状态压缩)

    题目链接:hdu 4856 Tunnels 题目大意:给定一张图,图上有M个管道,管道给定入口和出口,单向,现在有人想要体验下这M个管道,问最短需要移动的距离,起点未定. 解题思路:首先用bfs处理出两两管道之间移动的距离,然后后用状态压缩求出最短代价,dp[i][j],i表示的已经走过的管道,j是当前所在的管道. #include <cstdio> #include <cstring> #include <queue> #include <algorithm&g

    hdu 4352 数位dp + 状态压缩

    XHXJ's LIS Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2265    Accepted Submission(s): 927 Problem Description #define xhxj (Xin Hang senior sister(学姐)) If you do not know xhxj, then careful

    HDU 4921 Map DFS+状态压缩+乘法计数

    算最多十条链,能截取某前缀段,每种方案都可以算出一个权值,每种方案的概率都是总数分之一,问最后能构成的所有可能方案数. 对计数原理不太敏感,知道是DFS先把链求出来,但是想怎么统计方案的时候想了好久,其实因为只能取某个链的前缀,所以直接取链长加+1 然后相乘即可,当然因为会出现都是空的那种情况,要去掉,全部乘完之后,要-1 然后就是算权值了,权值等于当前加进来的点的总和 以及 等级相同的点的加成,并不是特别好算,这时候考虑每个状态下的点对全局的贡献,对,就是这个思想,用状态压缩来表示状态,然后这